#include <stdio.h>

class Point {
 public:
  double x,y;
  Point(double x0 = 0.0, double y0 =0.0) : x (x0), y (y0) {};
  Point operator ++ (int);
  Point operator -- (int); //䨪
  friend Point operator ++ (Point &);
  friend Point operator -- (Point &); //䨪
  Point operator + (Point &); //
  Point operator - (Point &);
  Point operator - (); //㭠
  void show (char *);
};

Point Point::operator - () { return Point(-x,-y); }

Point Point::operator ++ (int) {  return Point(x++,y++); }

Point Point::operator -- (int) {  return Point(x--,y--); }

Point operator ++ (Point &p) { return Point(++p.x,++p.y); }

Point operator -- (Point &p) { return Point(--p.x,--p.y);  }

Point Point::operator+ (Point &p) { return Point (x + p.x, y + p.y); }

Point Point::operator- (Point &p) { return Point (x - p.x, y - p.y); }

void Point:: show (char *s) { puts(s); printf ("x=%.2lf,y=%.2lf\n",x,y); }

void main () {
 Point origin; //(0,0)

 Point p1= Point (1,2);
 p1.show ("p1");
 Point p2=origin + p1++;
 p2.show("0+p1++");
 p1.show ("p1 ");
 p1--;
 p2= origin + ++p1;
 p2.show("0+ ++p1");

 p1 = Point (1,2);
 p1.show ("New p1");
 p2=origin - p1--;
 p2.show("0-p1--");
 p1++;
 p2= origin - --p1;
 p2.show("0- --p1");

 Point p3=-Point(1,-4);
 p3.show("-(1,-4)");
}